<template>
<center>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <div class="row">
        <div class="col-12 col-md-6">
            <div class="col-12">
                <h5>Outlets with Low BCF</h5>
                <bcf-remaining :chart-data="this.datacollection"></bcf-remaining>
            </div>
            <div class="col-12">
                <h5>Recent Transactions</h5>
                <ul id="example-2">
                    <li v-for="(item, index) in recent_transactions" v-bind:key="index">
                        {{ item }}
                    </li>
                </ul> 
            </div>
            <div class="col-12">
                <h5>Top Provider Earnings</h5>
                <provider-earnings :chart-data="this.top_earnings_provider"></provider-earnings>
            </div>
        </div>
        <div class="col-12 col-md-6">
            <div class="col-12">
                <h5>Top Outlets with Unique Players</h5>
                <top-unique-outlets :chart-data="this.top_unique_players" :options="this.options"></top-unique-outlets>
            </div>
            <div class="col-12">
                <h5>Top Outlets with Sessions</h5>
                <top-unique-outlets :chart-data="this.top_unique_sessions"></top-unique-outlets>
            </div>
        </div>
    </div>
</center>
</template>

<script>
  import BarChart from './Charts/BarChart'
  import HorizontalBarChart from './Charts/HorizontalBarChart'
  const socket = new window.Pusher(process.env.MIX_PUSHER_APP_KEY, {
    cluster: process.env.MIX_PUSHER_APP_CLUSTER,
    forceTLS: true
  });
  const channel = socket.subscribe('watchlist')
  export default {
       components: {
           "bcf-remaining" : HorizontalBarChart,
           "provider-earnings" : HorizontalBarChart,
           "top-unique-outlets" : BarChart,
           "top-unique-sessions" : BarChart
       },
    data () {
      return {
        outlets: null,
        remaining_bfc: null,
        outlet_names: null,
        providers: null,
        provider_names: null,
        datacollection: null,
        recent_transactions: null,
        top_unique_players: null,
        top_unique_sessions: null,
        top_earnings_provider:null,
        
        pathName: 'http://io.egms.macqalln.me/',
        options: {
            onClick: (evt, item) => {
                this.showProvidersPerOutlet(item);
            }
        }
      }
    },
    created () {
      this.fetchData()
      this.fillData()
    },
    mounted () {
      this.fillData()
    },
    methods: {
      showProvidersPerOutlet: function(item) {
          if(item.length > 0){
            var label = item[0]['_model']['label'];
            var index = item[0]['_index'];
            var outlet_id = item[0]['_chart']['data']['datasets'][0]['id'][index];
            
            axios({
                method: 'post',
                url: this.pathName+'api/get/watchlist/outlet/',
                data: {'outlet_id':outlet_id}
            }).then(response=>{
                console.log(response);
            }).catch(function(error){
                console.log('erros : ',error);
            }) 

          }
      },
      fillData () {
        this.queryData();
      },
      queryData(){
        axios.get(this.pathName+'/api/get/watchlist')
          .then(response => {
            console.log(response.data);
            let recent_transactions = response.data.bcf_remaining.recent
            let results = response.data.bcf_remaining.results   
            let outlets = results.map(a => a.outlet_id)
            let remaining_bfcs = results.map(a => a.bcf_transaction_remaining)
            let outlet_names = results.map(a => "["+a.provider_name+"] "+a.outlet_name+" ["+a.bcf_transaction_remaining+"]")
            let providers = results.map(a => a.provider_id)
            let provider_names = results.map(a => a.provider_name)
            
            let top_unique_players_outletname = response.data.daily_stat_outlet.rankings.top_unique_players.map(a => a.outlet_name);
            let top_unique_players_outletid = response.data.daily_stat_outlet.rankings.top_unique_players.map(a => a.outlet_id);
            let top_unique_players_count = response.data.daily_stat_outlet.rankings.top_unique_players.map(a => a['Unique Players Played']);
            this.top_unique_players = {
                labels: top_unique_players_outletname,
                datasets: [
                    {
                        label: "Unique Players",
                        backgroundColor: '#f87979',
                        id: top_unique_players_outletid,
                        data: top_unique_players_count
                    }
                ]
            };

            let top_unique_sessions_outletname = response.data.daily_stat_outlet.rankings.top_unique_sessions.map(a => a.outlet_name);
            let top_unique_sessions_count = response.data.daily_stat_outlet.rankings.top_unique_sessions.map(a => a['Sessions Played']);
            this.top_unique_sessions = {
                labels: top_unique_sessions_outletname,
                datasets: [
                    {
                        label: "Unique Sessions",
                        backgroundColor: '#f87979',
                        data: top_unique_sessions_count
                    }
                ]
            };
            
            let top_provider_earnings_providername = response.data.daily_stat_provider.rankings.top_earnings.map(a => a.provider_name +" ["+a.outlet_name+"]");
            let top_provider_earnings_amount = response.data.daily_stat_provider.rankings.top_earnings.map(a => a['Cash In Hand']);
            this.top_earnings_provider = {
                labels: top_provider_earnings_providername,
                datasets: [
                    {
                        label: "Top Provider Earnings",
                        backgroundColor: '#f87979',
                        data: top_provider_earnings_amount
                    }
                ]
            };

            this.recent_transactions = recent_transactions;
            this.outlets = outlets
            this.remaining_bfcs = remaining_bfcs
            this.outlet_names = outlet_names
            this.providers = providers
            this.provider_names = provider_names
            this.datacollection = {
                labels: outlet_names,
                datasets: [
                    {
                    label: 'Remaining BCFs',
                    backgroundColor: '#f87979',
                    data: remaining_bfcs
                    }
                ]
            }
          })
          .catch(error => {
            console.log(error)
          })
      },
    //   addExpenses () {
    //     let expense = this.expenseamount
    //     let income = this.incomeamount
    //     let today = moment().format('MMMM Do YYYY')
    //     axios.post('/expense/add', {
    //       expense: expense,
    //       income: income,
    //       date: today
    //     })
    //       .then(response => {
    //         this.expenseamount = ''
    //         this.incomeamount = ''
    //         channel.bind('new-expense', function (data) {
    //           let results = data.newExpense.data
    //           let dateresult = results.map(a => a.date)
    //           let expenseresult = results.map(a => a.expense)
    //           let incomeresult = results.map(a => a.income)
    //           this.expense = expenseresult
    //           this.income = incomeresult
    //           this.date = dateresult
    //           this.datacollection = {
    //             labels: this.date,
    //             datasets: [
    //               {
    //                 label: 'Expense',
    //                 backgroundColor: 'transparent',
    //                 pointBorderColor: '#f87979',
    //                 data: this.expense
    //               },
    //               {
    //                 label: 'Income',
    //                 backgroundColor: 'transparent',
    //                 pointBorderColor: '#5bf8bf',
    //                 data: this.income
    //               }
    //             ]
    //           }
    //         })
    //       })
    //       .catch(error => {
    //         console.log(error)
    //       })
    //   },
      fetchData () {
        channel.bind('data-watchlist', data => {
            
            this.queryData();
        })
      }
    }
  }
</script>


<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
  .title {
    text-align: center;
    margin-top: 40px;
  }
  .subtitle {
    text-align: center;
  }
  .form {
    max-width: 600px;
    width: 100%;
    margin: 20px auto 0 auto;
  }
  .form h4 {
    text-align: center;
    margin-bottom: 30px;
  }
  h1, h2 {
  font-weight: normal;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
</style>